Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.2.0.CR1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.api.score.buildin.simple
Class SimpleScore

    java.lang.Object
      org.optaplanner.core.api.score.AbstractScore<SimpleScore>
          org.optaplanner.core.api.score.buildin.simple.SimpleScore

All Implemented Interfaces:
  Serializable, Comparable<SimpleScore>, Score<SimpleScore>

    public final class SimpleScore

extends AbstractScore<SimpleScore>

This `Score` is based on 1 level of int constraints.

This class is immutable.

See Also:
  `Score`, Serialized Form

Method Summary
`SimpleScore` | `add(SimpleScore augment)` Returns a Score whose value is (this + augment).
`int` | `compareTo(SimpleScore other)`
`SimpleScore` | `divide(double divisor)` Returns a Score whose value is (this / divisor).
`boolean` | `equals(Object o)`
`int` | `getScore()` The total of the broken negative constraints and fulfilled positive hard constraints.
`int` | `hashCode()`
`SimpleScore` | `multiply(double multiplicand)` Returns a Score whose value is (this * multiplicand).
`SimpleScore` | `negate()` Returns a Score whose value is (- this).
`static SimpleScore` | `parseScore(String scoreString)`
`SimpleScore` | `power(double exponent)` Returns a Score whose value is (this ^ exponent).
`SimpleScore` | `subtract(SimpleScore subtrahend)` Returns a Score whose value is (this - subtrahend).
`Number[]` | `toLevelNumbers()` Returns an array of numbers representing the Score.
`String` | `toString()`
`static SimpleScore` | `valueOf(int score)`

Methods inherited from class org.optaplanner.core.api.score.AbstractScore
`buildScorePattern, buildScorePattern, isCompatibleArithmeticArgument, parseLevelAsBigDecimal, parseLevelAsDouble, parseLevelAsInt, parseLevelAsLong, parseLevelStrings, parseLevelStrings`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### parseScore

    public static SimpleScore parseScore(String scoreString)

### valueOf

    public static SimpleScore valueOf(int score)

### getScore

    public int getScore()

  The total of the broken negative constraints and fulfilled positive hard constraints. Their weight is included in the total. The score is usually a negative number because most use cases only have negative constraints.

  Returns:
    higher is better, usually negative, 0 if no constraints are broken/fulfilled

### add

    public SimpleScore add(SimpleScore augment)

  Description copied from interface: `Score`
  Returns a Score whose value is (this + augment).

  Parameters:
    `augment` - value to be added to this Score
  Returns:
    this + augment

### subtract

    public SimpleScore subtract(SimpleScore subtrahend)

  Description copied from interface: `Score`
  Returns a Score whose value is (this - subtrahend).

  Parameters:
    `subtrahend` - value to be subtracted from this Score
  Returns:
    this - subtrahend, rounded as necessary

### multiply

    public SimpleScore multiply(double multiplicand)

  Description copied from interface: `Score`
  Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

  Parameters:
    `multiplicand` - value to be multiplied by this Score.
  Returns:
    this * multiplicand

### divide

    public SimpleScore divide(double divisor)

  Description copied from interface: `Score`
  Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

  Parameters:
    `divisor` - value by which this Score is to be divided
  Returns:
    this / divisor

### power

    public SimpleScore power(double exponent)

  Description copied from interface: `Score`
  Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

  Parameters:
    `exponent` - value by which this Score is to be powered
  Returns:
    this ^ exponent

### negate

    public SimpleScore negate()

  Description copied from interface: `Score`
  Returns a Score whose value is (- this).

  Returns:
    - this

### toLevelNumbers

    public Number[] toLevelNumbers()

  Description copied from interface: `Score`
  Returns an array of numbers representing the Score. Each number represents 1 score level. A greater score level uses a lower array index than a lesser score level.

  When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`. The length of the returned array must be stable for a specific `Score` implementation.

  For example: -0hard/-7soft returns new int{-0, -7}

  Returns:
    never null

### equals

    public boolean equals(Object o)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### compareTo

    public int compareTo(SimpleScore other)

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.2.0.CR1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2014 JBoss by Red Hat. All Rights Reserved.